blob: c3e1747a94599d0f4e779686a32f60269fd7b14b [file] [log] [blame]
Philipp Maier7f340852018-07-10 16:21:54 +02001#!/bin/bash
2
3# Utility to verify the functionality of pysim-prog.py
4#
5# (C) 2018 by Sysmocom s.f.m.c. GmbH
6# All Rights Reserved
7#
8# Author: Philipp Maier
9#
10# This program is free software: you can redistribute it and/or modify
11# it under the terms of the GNU General Public License as published by
12# the Free Software Foundation, either version 2 of the License, or
13# (at your option) any later version.
14#
15# This program is distributed in the hope that it will be useful,
16# but WITHOUT ANY WARRANTY; without even the implied warranty of
17# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18# GNU General Public License for more details.
19#
20# You should have received a copy of the GNU General Public License
21# along with this program. If not, see <http://www.gnu.org/licenses/>.
22
23PYSIM_PROG=../pySim-prog.py
24PYSIM_READ=../pySim-read.py
25TEMPFILE=temp.tmp
26
27set -e
28
29echo "pysim-test - a test program to test pysim-prog.py"
30echo "================================================="
31
32# Generate a list of the cards we expect to see by checking which .ok files
33# are present
34function gen_card_list {
35 N_CARDS=0
36
37 echo "Expecting to see the following cards:"
38
39 for I in *.data ; do
40 CARD_NAMES[$N_CARDS]=${I%.*}
41 CARD_SEEN[$N_CARDS]=0
42 N_CARDS=$((N_CARDS+1))
43 done
44
45 for I in $(seq 0 $((N_CARDS-1))); do
46 echo ${CARD_NAMES[$I]}
47 done
48}
49
50# Increment counter in card list for a specified card name (type)
51function inc_card_list {
52 CARD_NAME=$1
53 for I in $(seq 0 $((N_CARDS-1))); do
54 if [ $CARD_NAME = ${CARD_NAMES[$I]} ]; then
55 CARD_SEEN[$I]=$((${CARD_NAMES[$I]}+1))
56 fi
57 done
58}
59
60# Check the card list, each card must be seen exactly one times
61function check_card_list {
62 for I in $(seq 0 $((N_CARDS-1))); do
63 if [ ${CARD_SEEN[$I]} -ne 1 ]; then
64 echo "Error: Card ${CARD_NAMES[$I]} seen ${CARD_SEEN[$I]} times!"
65 exit 1
66 fi
67 done
68
69 echo "All cards seen -- everything ok!"
70}
71
72# Verify the contents of a card by reading them and then diffing against the
73# previously created .ok file
74function check_card {
75 TERMINAL=$1
76 CARD_NAME=$2
77 echo "Verifying card ..."
78 stat ./$CARD_NAME.ok > /dev/null
79 python $PYSIM_READ -p $TERMINAL > $TEMPFILE
80 set +e
Philipp Maier4e724392019-12-12 17:02:22 +010081 # Note: We ignore the first line of output in the diff because here
82 # pysim would print the device number of the reader and we do not
83 # want the test to fail just because the card is put into a different
84 # reader device.
85 CARD_DIFF=$(diff + 1 $TEMPFILE ./$CARD_NAME.ok)
Philipp Maier7f340852018-07-10 16:21:54 +020086 set -e
87
88 if [ "$CARD_DIFF" != "" ]; then
89 echo "Card contents do not match the test data:"
90 echo "Expected: $CARD_NAME.ok"
91 echo "------------8<------------"
92 cat "$CARD_NAME.ok"
93 echo "------------8<------------"
94 echo "Got:"
95 echo "------------8<------------"
96 cat $TEMPFILE
97 echo "------------8<------------"
98 exit 1
99 fi
100
101 inc_card_list $CARD_NAME
102
103 echo "Card contents match the test data -- success!"
104 rm $TEMPFILE
105}
106
107# Read out the card using pysim-read and store the result as .ok file. This
108# data will be used later in order to verify the results of our write tests.
109function gen_ok_file {
110 TERMINAL=$1
111 CARD_NAME=$2
112 python $PYSIM_READ -p $TERMINAL > "$CARD_NAME.ok"
113 echo "Generated file: $CARD_NAME.ok"
114 echo "------------8<------------"
115 cat "$CARD_NAME.ok"
116 echo "------------8<------------"
117}
118
119# Find out the type (card name) of the card that is installed in the specified
120# reader
121function probe_card {
122 TERMINAL=$1
123 RESULT=$(timeout 5 $PYSIM_PROG -p $TERMINAL -T | cut -d ":" -f 2 | tail -n 1 | xargs)
124 echo $RESULT
125}
126
127# Read out all cards and store the results as .ok files
128function gen_ok_files {
129 echo "== OK FILE GENERATION =="
130 for I in $(seq 0 $((N_TERMINALS-1))); do
131 echo "Probing card in terminal #$I"
132 CARD_NAME=$(probe_card $I)
133 if [ -z "$CARD_NAME" ]; then
134 echo "Error: Unresponsive card!"
135 exit 1
136 fi
137 echo "Card is of type: $CARD_NAME"
138 gen_ok_file $I $CARD_NAME
139 done
140}
141
142# Execute tests. Each card is programmed and the contents are checked
143# afterwards.
144function run_test {
145 for I in $(seq 0 $((N_TERMINALS-1))); do
146 echo "== EXECUTING TEST =="
147 echo "Probing card in terminal #$I"
148 CARD_NAME=$(probe_card $I)
149 if [ -z "$CARD_NAME" ]; then
150 echo "Error: Unresponsive card!"
151 exit 1
152 fi
153 echo "Card is of type: $CARD_NAME"
154
155 # Make sure some default data is set
156 MCC=001
157 MNC=01
158 ICCID=1122334455667788990
159 KI=FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
160 OPC=FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
161 IMSI=001010000000001
162 ADM=00000000
Philipp Maier4e724392019-12-12 17:02:22 +0100163 ADM_HEX=""
Daniel Willmannf432b2b2018-06-15 07:31:50 +0200164 ADM_OPT="-a"
Philipp Maier7f340852018-07-10 16:21:54 +0200165
Daniel Willmannf432b2b2018-06-15 07:31:50 +0200166 source "$CARD_NAME.data"
167 if [ -n "$ADM_HEX" ]; then
168 ADM_OPT="-A"
169 ADM=$ADM_HEX
170 fi
171 python $PYSIM_PROG -p $I -t $CARD_NAME -o $OPC -k $KI -x $MCC -y $MNC -i $IMSI -s $ICCID $ADM_OPT $ADM
Philipp Maier7f340852018-07-10 16:21:54 +0200172 check_card $I $CARD_NAME
173 echo ""
174 done
175}
176
177function usage {
178 echo "Options:"
179 echo "-n: number of card terminals"
180 echo "-o: generate .ok files"
181}
182
183# Make sure that the pathes to the python scripts always work, regardless from
184# where the script is called.
185CURDIR=$PWD
186SCRIPTDIR=$(dirname $0)
187cd $SCRIPTDIR
188PYSIM_PROG=$(realpath $PYSIM_PROG)
189PYSIM_READ=$(realpath $PYSIM_READ)
190cd $CURDIR
191
192OPT_N_TERMINALS=0
193OPT_GEN_OK_FILES=0
194while getopts ":hon:" OPT; do
195 case $OPT in
196 h)
197 usage
198 exit 0
199 ;;
200 o)
201 OPT_GEN_OK_FILES=1
202 ;;
203 n)
204 OPT_N_TERMINALS=$OPTARG
205 ;;
206 \?)
207 echo "Invalid option: -$OPTARG" >&2
208 exit 1
209 ;;
210 esac
211done
212
213N_TERMINALS=$OPT_N_TERMINALS
214
215# Generate a list of available cards, if no explicit reader number is given
216# then the number of cards will be used as reader number.
217gen_card_list
218if [ $N_TERMINALS -eq 0 ]; then
219 N_TERMINALS=$N_CARDS
220fi
221echo "Number of card terminals installed: $N_TERMINALS"
222echo ""
223
224if [ $OPT_GEN_OK_FILES -eq 1 ]; then
225 gen_ok_files
226 exit 0
227else
228 run_test
229 check_card_list
230 exit 0
231fi